<template>
  <q-dialog
    ref="dialogRef"
    :persistent="true"
    @hide="onDialogHide"
  >
    <q-stepper
      ref="stepper"
      v-model="step"
      class="q-dialog-plugin planner-dialog"
      color="primary"
      animated
    >
      <q-step
        :name="0"
        title="Jízda"
        caption="Vlak z/do nádraží"
        icon="timeline"
        :done="step > 0"
      >
        <journey-add
          :id="selectedId.journey"
          ref="journey"
          :show-btns="false"
          @onOKClick="onJourneyDone"
        />
      </q-step>

      <q-step
        :name="1"
        title="Jízdní řád"
        caption="Jízdy za sebou"
        icon="directions_transit_filled"
        :done="step > 1"
      >
        <timetable-add
          :id="selectedId.timetable"
          ref="timetable"
          :show-btns="false"
          @onOKClick="onTimetableDone"
        />
      </q-step>

      <q-step
        :name="2"
        title="Plán"
        caption="Spouštění jízdních řádů"
        icon="schedule"
      >
        <planner-add
          :id="selectedId.planner"
          ref="planner"
          :show-btns="false"
          @onOKClick="onPlannerDone"
        />
      </q-step>
      <template #navigation>
        <q-stepper-navigation
          align="right"
        >
          <q-btn
            :color="step === 2 ? 'positive' : 'primary'"
            :icon="step === 2 ? 'check' : 'navigate_next'"
            :label="step === 2 ? 'Dokončit' : 'Dále'"
            @click="onOKClick"
          />
          <q-btn
            flat
            color="primary"
            label="Přeskočit"
            class="q-ml-sm"
            @click="onSkipClick"
          />
          <q-btn
            color="negative"
            :label="step === 0 ? 'Zrušit' : 'Zpět'"
            :icon="step === 0 ? 'cancel' : 'navigate_before'"
            class="q-ml-sm"
            @click="onCancelClick"
          />
        </q-stepper-navigation>
      </template>
    </q-stepper>
  </q-dialog>
</template>
<script lang="ts">
import { reactive, ref } from '@vue/reactivity'
import { useDialogPluginComponent } from 'quasar'
import { defineComponent } from 'vue'
import { JourneyModel, PlannerModel, TimetableModel } from 'web_trains_types'

import JourneyAdd from '@/components/Timetable/JourneyAdd.vue'
import PlannerAdd from '@/components/Timetable/PlannerAdd.vue'
import TimetableAdd from '@/components/Timetable/TimetableAdd.vue'

export default defineComponent({
  name: 'Guide',
  components: {
    JourneyAdd,
    PlannerAdd,
    TimetableAdd
  },
  emits: [
    ...useDialogPluginComponent.emits
  ],
  setup (): any {
    const { dialogRef, onDialogHide, onDialogOK, onDialogCancel } = useDialogPluginComponent()

    const step = ref(0)
    const stepper = ref()

    const journey = ref()
    const timetable = ref()
    const planner = ref()

    const stepRef = [
      journey, timetable, planner
    ]

    const journeyTabs = ref(1)

    const selectedId = reactive({
      journey: 0,
      timetable: 0,
      planner: 0
    })

    const onJourneyDone = (data: JourneyModel|undefined) => {
      stepper.value.next()

      if (data !== undefined) {
        selectedId.journey = data.id
      }
    }

    const onTimetableDone = (data: TimetableModel|undefined) => {
      stepper.value.next()

      if (data !== undefined) {
        selectedId.timetable = data.id
      }
    }

    const onPlannerDone = (data: PlannerModel|undefined) => {
      stepper.value.next()

      if (data !== undefined) {
        selectedId.planner = data.id
      }

      onDialogOK()
    }

    const onOKClick = () => {
      stepRef[step.value].value.submit()
    }

    const onCancelClick = () => {
      if (step.value === 0) {
        onDialogCancel()
      }

      stepper.value.previous()
    }

    const onSkipClick = () => {
      if (step.value === 2) {
        onDialogOK()
      }

      stepper.value.next()
    }

    return {
      dialogRef,
      onDialogHide,
      onCancelClick,
      onOKClick,
      step,
      stepper,
      journey,
      timetable,
      planner,
      onJourneyDone,
      onTimetableDone,
      onPlannerDone,
      selectedId,
      journeyTabs,
      onSkipClick
    }
  }
})

</script>
